#include "functionDemo.h"


//--------------------------------------------------------------
void functionDemo::setup(){	 
	
	ofBackground(255,255,255);
	
	// creating functions
	// functions are declared in header (.h) file
	// functions are created in .cpp file
	
	// the declaration for addTwoNumbers is:
	// int addTwoNumbers( int number1, int number2 );
	// its behaviour is defined below - it's class name is attached to it 
	
	/*
	
	int functionDemo::addTwoNumbers( int number1, int number2 ){

		return (number1+number2);
	}
	
	this function adds two numbers together and returns the results
	the function is defined as receiving two intergers and returning an interger
	a function that returns nothing is declared as void myFunction(int myArguments)
	
	*/
	
	// the function is called as follows
	
	int results = addTwoNumbers(1, 2);
	
	printf("results of addTwoNumbers: %i\n", results);
	
	printf("--\n");
	
	// ---------------------------------------------
	// PASSING BY COPY
	// function creates and mofifies copy of value, old one left unchanged

	int myInteger = 5;
	
	printf("before increment by copy: %i\n", myInteger);
	
	incrementIntegerByCopy(myInteger);
	
	printf("after increment by copy: %i\n", myInteger);
	
	printf("--\n");
	
	
	// ---------------------------------------------
	// increment by copy, return new value
	// function creates and mofifies copy of value
	// function returns value of copy, assigning it to the original variable 
	
	myInteger = 5;
	
	printf("before increment return new value: %i\n", myInteger);
	
	myInteger = incrementIntegerReturn(myInteger);
	
	printf("after increment return new value: %i\n", myInteger);
	
	printf("--\n");
	
	
	// ---------------------------------------------
	// PASSING BY REFERENCE
	// function sends memory location of value, modifies value at memory location
	// original value is changed
	// function uses & (reference) to refer to the location of the variable in the computers memory
	
	myInteger = 5;
	
	printf("before increment by reference: %i\n", myInteger);
	
	incrementIntegerByReference(myInteger);
	
	printf("after increment by reference: %i\n", myInteger);
	
	printf("--\n");
	
	
	// ---------------------------------------------
	// PASSING BY POINTER
	// function sends memory location of value, modifies value at memory location
	// original value is changed
	// function uses * (pointer) to refer to the location of the variable in the computers memory
	
	myInteger = 5;
	
	printf("before increment by pointer: %i\n", myInteger);
	
	int * pointerToInt = &myInteger;
	
	incrementIntegerByPointer(pointerToInt);
	
	printf("after increment by pointer: %i\n", myInteger);
	
	printf("--\n");
	
}

int functionDemo::addTwoNumbers( int number1, int number2 ){

	return (number1+number2);
}

//--------------------------------------------------------------
void functionDemo::update(){

}

//--------------------------------------------------------------
void functionDemo::draw(){

}

//--------------------------------------------------------------
void functionDemo::incrementIntegerByCopy(int old){

	old++;
	
	printf("inside increment by copy: %i\n", old);
}

//--------------------------------------------------------------
void functionDemo::incrementIntegerByReference(int & old){

	old++;
	
	printf("inside increment by reference: %i\n", old);
}

//--------------------------------------------------------------
void functionDemo::incrementIntegerByPointer(int * old){

	printf("the memory address of the varaible is: %x\n", old);

	(*old)++;
	
	printf("inside increment by pointer: %i\n", *old);
}

//--------------------------------------------------------------
int functionDemo::incrementIntegerReturn(int old){

	int newValue = ++old;
	
	printf("inside increment return new value: %i\n", old);

	return newValue;
}


//--------------------------------------------------------------
void functionDemo::keyPressed  (int key){ 
	
}

//--------------------------------------------------------------
void functionDemo::keyReleased(int key){ 
	
}

//--------------------------------------------------------------
void functionDemo::mouseMoved(int x, int y ){
	
}

//--------------------------------------------------------------
void functionDemo::mouseDragged(int x, int y, int button){
	
}

//--------------------------------------------------------------
void functionDemo::mousePressed(int x, int y, int button){

}

//--------------------------------------------------------------
void functionDemo::mouseReleased(){
}
